#pragma once

#include <unordered_map>
#include <functional>
#include <string>
#include <list>

struct EventHandler;
class MyPropertySystem;

using EntryName = std::string;  //to remove event
using EventId = std::string;
using EventFunc = std::function<bool(MyPropertySystem)>;
using EventList = std::list<EventHandler>;
using EventMap = std::unordered_map<EventId, EventList>;
using EnteryMap = std::unordered_map<EntryName, EventId>;

struct EventHandler
{
    EventId eventId;
    EventFunc func;
    EntryName entryName;
};

class EventManager
{
private:
    EventMap m_eventMap;
    EnteryMap m_entryMap;

public:
    EventManager();
    bool AddEvent(EventId eventId, EventFunc eventFunc);
    bool AddEvent(EventId eventId, EventFunc eventFunc, EntryName entryName);
    bool RemoveEvent(EntryName entryName);
    void Update(EventId eventId, const MyPropertySystem& param);
};

