#include <stdio.h>
# include <conio.h>  
#include <string>
#include <iostream>
#include "EventManager.h"
#include "property/PropertyType.h"
#include "property/MyProperty.h"
#include "property/MyPropertySystem.h"


struct Car
{
    std::string name;
    int ShowPrice(MyPropertySystem propertySystem)
    {
        PropertyList list = propertySystem.GetList();
        for (auto p : list)
        {
            std::cout << name << " : " <<  p->GetName() << " : " << p->GetTypeName() << " : " << ToString(p) << std::endl;
        }
        return 0;
    }

    int ShowLowPrice(MyPropertySystem propertySystem)
    {
        PropertyList list = propertySystem.GetList();
        for (auto p : list)
        {
            std::cout << name << " : "  << p->GetName() << " : " << p->GetTypeName() << " : " << ToString(p) << std::endl;
        }
        return 0;
    }
};

using  namespace  std::placeholders;
void DoTest()
{
    std::cout << "============ MyProperty Test ============" << std::endl;
    MyProperty<bool> boolTest("boolTest");
    boolTest = true;
    std::cout << boolTest.GetName() << " : " << boolTest.GetTypeName() << " : " << boolTest << std::endl;
    MyProperty<int> intTest("intTest");
    intTest = 10;
    std::cout << intTest.GetName() << " : " << intTest.GetTypeName() << " : " << intTest << std::endl;
    MyProperty<std::string> stringTest("stringTest");
    stringTest = "hello world!!!";
    std::cout << intTest.GetName() << " : " << stringTest.GetTypeName() << " : " << stringTest << std::endl;

    std::cout << "============ MyPropertySystem Test ============" << std::endl;
    MyPropertySystem prop;
    prop.GetValue<int>("Damage") = 100;
    prop.GetValue<float>("hp") = 1000;
    prop.GetValue<std::string>("class") = "worrior";
    prop.GetValue<bool>("alive") = true;

    IProperty* damageProp = prop.GetProperty("Damage");
    IProperty* hpProp = prop.GetProperty("hp");
    IProperty* classProp = prop.GetProperty("class");
    IProperty* aliveProp = prop.GetProperty("alive");

    std::cout << damageProp->GetName() << " : " << damageProp->GetTypeName() << " : " << ToString(damageProp) << std::endl;
    std::cout << hpProp->GetName() << " : " << hpProp->GetTypeName() << " : " << ToString(hpProp) << std::endl;
    std::cout << classProp->GetName() << " : " << classProp->GetTypeName() << " : " << ToString(classProp) << std::endl;
    std::cout << aliveProp->GetName() << " : " << aliveProp->GetTypeName() << " : " << ToString(aliveProp) << std::endl;

    std::cout << "============ Test AddEvent: add NormalPrice, LowPrice ============" << std::endl;
    EventManager manager;
    Car car1;
    car1.name = "an electric car";
    Car car2;
    car2.name= "a gasoline car";

    manager.AddEvent("Update_Price", std::bind(&Car::ShowPrice, &car1, _1), "NormalPrice");
    manager.AddEvent("Update_Price", std::bind(&Car::ShowLowPrice, &car2, _1), "LowPrice");

    MyPropertySystem param;
    param.GetValue<int>("price") = 1000;
    param.GetValue<bool>("isAll") = true;
    manager.Update("Update_Price", param);

    std::cout << "============ Test RemoveEvent : remove NormalPrice ============" << std::endl;
    manager.RemoveEvent("NormalPrice");

    MyPropertySystem param1;
    param1.GetValue<int>("price") = 100;
    param1.GetValue<float>("percent") = 50.5f;

    manager.Update("Update_Price", param1);
}

int main()
{
    _CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
    {
        DoTest();
    }
    _getch();
    return 0;
}