//PropertyType.h

#ifndef _PROPERTYTYPE_H
#define _PROPERTYTYPE_H

#include <crtdbg.h>
#ifdef _DEBUG
#define new new(_CLIENT_BLOCK,__FILE__,__LINE__)
#endif

enum ePropertyType
{
    ept_bool,
    ept_int,
    ept_float,
    ept_string,
    ept_ptr,
    eptMAX_PROPERTY_TYPES
};

template <class T> 
class PropertyType
{
public :
    // Returns type ID associated with the templatized type.
    static  ePropertyType GetTypeID()
    {
        return ms_typeID;
    }
    static  const char* GetTypeName()
    {
         return ms_typeName;
    }

private:
    static  ePropertyType ms_typeID;
    static  const char* ms_typeName;
};

template<class T> ePropertyType PropertyType<T>::ms_typeID = ept_ptr;
template<class T> const char* PropertyType<T>::ms_typeName = "ptr";

//template<> ePropertyType PropertyType<bool>::ms_typeID = ept_bool;
//template<> char* PropertyType<bool>::ms_typeName = (char*)"bool";
template<> ePropertyType PropertyType<bool>::GetTypeID() { return ept_bool; }
template<> const char* PropertyType<bool>::GetTypeName() { return static_cast<const char*>("bool"); }

//template<class T> ePropertyType PropertyType<int>::ms_typeID = ept_int;
//template<class T> char*   PropertyType<int>::ms_typeName = "int";
template<> ePropertyType PropertyType<int>::GetTypeID() { return ept_int; }
template<> const char* PropertyType<int>::GetTypeName() { return static_cast<const char*>("int"); }

//template<> ePropertyType PropertyType<float>::ms_typeID = ept_float;
//template<> char* PropertyType<float>::ms_typeName = "float";
template<> ePropertyType PropertyType<float>::GetTypeID() { return ept_float; }
template<> const char* PropertyType<float>::GetTypeName() { return static_cast<const char*>("float"); }

//template<std::string> ePropertyType PropertyType<std::string>::ms_typeID = ept_string;
//template<std::string> char* PropertyType<std::string>::ms_typeName = "string";
template<> ePropertyType PropertyType<std::string>::GetTypeID() { return ept_string; }
template<> const char* PropertyType<std::string>::GetTypeName() { return static_cast<const char*>("string"); }

#endif  